import { LazyExoticComponent, ComponentType, ReactNode } from "react";
import { RouteProps, RouteComponentProps } from "react-router-dom";
import { History } from "history";

export type Loadding = ReactNode;

export type Loader<T> = () => Promise<{ default: T }>;

export type AsyncLoader<T extends ComponentType<any>> = (
  factory: Loader<T>
) => LazyExoticComponent<T>;

export type RouteLocation = RouteComponentProps["location"];
export interface LoadableLocation extends RouteLocation {
  query?: any;
}
export interface LoadableProps {
  loader: () => Promise<any>;
  loading?: Loadding;
  routeProps?: RouteComponentProps;
  location?: LoadableLocation;
  routerParams?: object;
}

export type LazyRouteProps = RouteProps & {
  loader: () => Promise<any>;
  loading?: Loadding;
};

export type RouteComponentType = ComponentType<any>;
export interface RouterProviderProps<
  T extends RouteComponentType = RouteComponentType
> {
  history?: History;
  loading?: Loadding;
  asyncLoader?: AsyncLoader<T>;
}
