import { LazyExoticComponent, ComponentType, ReactNode } from "react";
import { RouteProps, RouteComponentProps } from "react-router-dom";
import { History } from "history";
export declare type Loadding = ReactNode;
export declare type Loader<T> = () => Promise<{
    default: T;
}>;
export declare type AsyncLoader<T extends ComponentType<any>> = (factory: Loader<T>) => LazyExoticComponent<T>;
export declare type RouteLocation = RouteComponentProps["location"];
export interface LoadableLocation extends RouteLocation {
    query?: any;
}
export interface LoadableProps {
    loader: () => Promise<any>;
    loading?: Loadding;
    routeProps?: RouteComponentProps;
    location?: LoadableLocation;
    routerParams?: object;
}
export declare type LazyRouteProps = RouteProps & {
    loader: () => Promise<any>;
    loading?: Loadding;
};
export declare type RouteComponentType = ComponentType<any>;
export interface RouterProviderProps<T extends RouteComponentType = RouteComponentType> {
    history?: History;
    loading?: Loadding;
    asyncLoader?: AsyncLoader<T>;
}
